;********************************
;	 1.0  MSX	*
;	==================	*
;	  Yamaha YIS503		*
;********************************
.nolist
.include "m48def.inc"
.list
;****************************************
;	  		*
;****************************************
.equ	F_clk	= 80000		;     
.equ	tab_kbd	= 0x400/2	;
.equ	alttab	= 0x500/2	;
;----------------------------------------
;	 
.def	tempA		=r1
.def	paritet		=r2	;  
.def	r_FF		=r3	; FF
.def	r_00		=r4	; 00
.def	t_kbd		=r5	; - 
.def	temp_S		=r15	;   SREG
;-------
.def	STATUS		=r16	;  
.def	STATUS2		=r17	;   KBD
.def	temp		=r18
.def	count		=r19	;
.def	scanFF	 	=r20	;GLOBAL	; 
.def	data		=r21	; data transfer register
;----------------------------------------------------------
; PORTD -     ()
	.equ	A0	= 0
	.equ	A1	= 1
	.equ	A2	= 2
	.equ	A3	= 3
	.equ	A4	= 4
	.equ	A5	= 5
	.equ	A6	= 6
	.equ	A7	= 7
; PORTB -      ()
	.equ	D0	= 0
	.equ	D1	= 1
	.equ	D2	= 2
	.equ	D3	= 3
	.equ	D4	= 4
	.equ	D5	= 5
	.equ	D6	= 6
	.equ	D7	= 7
; PORT
.equ	init_DDRC	= 0x00  ;1-,0-
.equ	init_PORTC	= 0x3f	;
	.equ	CLK	= 5	; inp | PS/2
	.equ	DAT	= 4	; inp | PS/2
	.equ	CAPS	= 3	; inp | CAPS+KANA
	.equ	in_A10	= 2	; inp | KA10
	.equ	in_A9	= 1	; inp | KA9
	.equ	in_A8 	= 0	; inp | KA8
;----------------------------------------------
; STATUS:
	.equ	f_sh_off= 0	;1 -   Shift
	.equ	f_off	= 1	;1 -   
	.equ	f_clr	= 2	;1 -   
	.equ	f_scan	= 3	;1 -   
	.equ	f_shift = 4	;1 -   Shift
	.equ	f_ctrl  = 5	;1 -   Ctrl
	.equ	p_ctrl	= 6	;1 -   Ctrl
;  d2 - Caps Lock; d1 - Num Lock; d0 - Scroll Lock
; STATUS2:
	.equ ScrLoc	= 0	;/KANA 0-LAT, 1-RUS
	.equ NumLoc	= 1	;
	.equ CapLoc	= 2	;/CAPS 0-Off, 1-On
;----------------------------------------------------------
;	   
.equ	Bufer	= 0x100		;    (8 )
.equ	Bufer2	= 0x110		;   (16 )
.equ	steck	= 0x170-1	;  
.equ	Bufer_SC= 0x170 ; 0x1ff;   -
;########################################################
;	  
.CSEG
	rjmp	programm	;  Reset
;==========================================================
	reti			;INT0
	reti			;INT1
	reti			;PCINT0 PORTB
;==========================================================
;   PORTC    
				;7 PCINT1 PORTC
	nop			;1
;==========================================================
;   PORTD    
				;7 PCINT2 PORTD
	in	temp_S,SREG	;1  
;     Y7...Y0
	in	YL,PIND		;1  Y7..Y0
	cpi	YL,0xff		;1      0 ?
	brne	yes_scan7_0	;2/1 
;   Y10..Y8
	in	YL,PINC		;1  Y10..Y8
	andi	YL,0x07		;1   Y10..Y8
	ori	YL,LOW(Bufer_SC);1 +   
yes_scan7_0:
	ld	scanFF,Y	;2 -   .
 	out	DDRB,scanFF	;1     = 0
				;10 
;    <B> -  
	out	PCIFR,r_FF	;  
;-------
	out	SREG,temp_S	;1  
	reti			;4 
;==========================================================
;	reti			;WDT
;	reti			;T2 COMPA
;	reti			;T2 COMPB
;	reti			;T2 OVF
;	reti			;T1 CAPT
;	reti			;T1 COMPA
;	reti			;T1 COMPB
;	reti			;T1 OVF
;	reti			;T0 COMPA
;	reti			;T0 COMPB
;	reti			;T0 OVF
;	reti			;SPI STC
;	reti			;USART RX
;	reti			;USART UDRE
;	reti			;USART TX
;	reti			;ADC
;	reti			;ANALOG COMP
;	reti			;TWI
;	reti			;SPM READY
;**********************************************************
;**************	   RESET *****************
;**********************************************************
programm:
	ldi	temp,LOW(steck)	; 
	out	SPL,temp	;  
	ldi	temp,HIGH(steck)
	out	SPH,temp
;	 
; PORTD -   
	clr	r_00		;0x00
	out	DDRD,r_00	;   
	ser	temp		;0xff
	mov	r_FF,temp
	out	PORTD,r_FF	;   +5V
; PORTB -    
	out	DDRB,r_00	;   
	out	PORTB,r_00	;  0
; PORTC -  
	ldi	temp,init_DDRC
	out	DDRC,temp
	ldi	temp,init_PORTC
	out	PORTC,temp
;  
	ldi	temp,1<<ACD	;ACD=1
	out	ACSR,temp
;      CAPS  KANA
	ldi	temp,0x63	;REF=AVCC;ADLAR=1;ADC3
	sts	ADMUX,temp
	ldi	temp,0xa0	;ADEN=1;ADATE=1; DIV=2
	sts	ADCSRA,temp
	ldi	temp,0x08	;ADC3D=1	;
	sts	DIDR0,temp
	ldi	temp,0x00	;Free Runing mode ADC
	sts	ADCSRB,temp
;  ADC   FREE RUNNING MODE
	ldi	temp,0xe0	;ADEN=1;ADSC=1,ADATE=1;DIV=2
	sts	ADCSRA,temp	;
;	 
; PCINT2 -      A0..A7 ( D)
; PCINT1 -      A8..A9 ( C)
	ldi	temp,1<<PCIE2|1<<PCIE1	; PCINT2  PCINT1
	sts	PCICR,temp
	sts	PCMSK2,r_FF	;   PCINT2
	ldi	temp,0x03	; PCINT1/0..1
	sts	PCMSK1,temp	;  A8,A9
;===================================================
	rcall	del_05		;  0.5 
;	 
no_kbd:
;	   KBD ( = 0xFF)
	ldi	data,0xff 	; ""
	rcall	trans_ack	;
				;  ACK  
	brne	no_kbd		; 
; 			   AAh
	rcall	receive		;   (0AAh)
;    
;  d2 - Caps Lock; d1 - Num Lock; d0 - Scroll Lock
	ldi	STATUS2,0x02	; Num Lock
	rcall	set_ind
;--  Num Lock	* _ _
	rcall	del_05		; 0.5 
	ldi	STATUS2,0x00	;Locks=0,0,0
	rcall	set_ind
;--   
	ldi	data,0xf0	;Select Alt_Scan
	rcall	trans_ack	;
	ldi	data,0x03	;Alt_Scan = 3
	rcall	trans_ack	;
;
	ldi	data,0xf8	;Select All Make/Break
	rcall	trans_ack	;
;********************************************************
;	   			*
;********************************************************
clr_cikl:
	rcall	clr_buf		; 
;/-------------------------------
main_cikl:
;   ( KANA  CAPS LOCK)
	lds	data,ADCH	;  ADC
	clt			; T   LOCKS
; /KANA=1,CAPS=1 -> 111xxxxx
; /KANA=0,CAPS=1 -> 100xxxxx
; /KANA=1,CAPS=0 -> 011xxxxx
; /KANA=0,CAPS=0 -> 010xxxxx
;        
; STATUS2
;  d2 - Caps Lock; d1 - Num Lock; d0 - Scroll Lock
;   /KANA
	sbrs	data,5		;/KANA=1
	rjmp	kana_0
;  /KANA = 1, Scroll Lock   = 0 ( )
	sbrs	STATUS2,ScrLoc
	rjmp	kana_ok		; 
;  ScrLock  0
	cbr	STATUS2,1<<ScrLoc
	set			;   T=1
	rjmp	kana_ok
kana_0:
;  /KANA = 0, Scroll Lock   = 1
	sbrc	STATUS2,ScrLoc
	rjmp	kana_ok		; 
;  ScrLock  1
	sbr	STATUS2,1<<ScrLoc
	set			;   T=1
kana_ok:
;   /CAPS
	sbrs	data,7		;/CAPS=1
	rjmp	caps_0
;  /CAPS = 1, CAPS Lock   = 0
	sbrs	STATUS2,CapLoc
	rjmp	caps_ok		;
;  CapLock  0
	cbr	STATUS2,1<<CapLoc
	set			;
	rjmp	caps_ok
caps_0:
;  /CAPS = 0, CAPS Lock   = 1
	sbrc	STATUS2,CapLoc
	rjmp	caps_ok		;
;  CapLock  1
	sbr	STATUS2,1<<CapLoc
	set			;
caps_ok:
	brtc	lock_ok		; T=0,   
	rcall	set_ind		; ,  	
lock_ok:
;    
	rcall	receive		; 
	tst	data		;  = 0 - time out
	breq	main_cikl	;  
;    
	cpi	data,0xf0	;   ?
	brne	no_rec_off
;====    (0F0h) =================
	sbr	STATUS,1<<f_off	; = 1
	rjmp	main_cikl	;  .
no_rec_off:
;===================================================
;  -  	============
	cpi	data,0x58	; Right Ctrl  0x58
	brne	no_58
	ldi	data,0x11	; Left Ctrl   0x11
no_58:
	cpi	data,0x59	; Right Shift 0x59
	brne	no_59
	ldi	data,0x12	; Left Shift  0x12
no_59:
;   [-]  80h,   
	cpi	data,0x84	;   [-]
	brne	no_84
	ldi	data,0x09	;   0x09
no_84:
;   Flying Windows
	cpi	data,0x8b	; Left Flying Win
	brlo	no_flying
	subi	data,(0x8b-0x0a);-> 0x0a,b,c
no_flying:
;   -		============
;===================================================
;     
	sbrc	STATUS,f_off
	rjmp	rec1off		;  
; ---
	cp	t_kbd,data	; 
	breq	main_cikl	; , 
;***     ************************
	mov	t_kbd,data	;  
;--------------------------------------------------------
;----  -   --------------
;--------------------------------------------------------
; 1)    Shift
	cpi	data,0x12	;  Shift ?
	brne	no_shift_on	; 
;  Shift   
	sbr	STATUS,1<<f_shift;  
	rjmp	new_scan	; 
no_shift_on:
;-----------
; 2)   Num Lock
	cpi	data,0x76	;  Num Lock ?
	brne	no_num_lock
;  Num Lock
	ldi	temp,1<<NumLoc	;
inv_ind:
	eor	STATUS2,temp	;
	rcall	set_ind		; 
	rjmp	main_cikl	;
no_num_lock:
;--------------------------------------------------------
;***         ***
	ldi	XH,HIGH(Bufer)
	ldi	XL,LOW(Bufer)	;  
;//---
c_wr_buf:
	ld	temp,X+		;  
	tst	temp		;   0,
	brne	no_00		;  
;    
	st	-X,data		;    
	rjmp	new_scan	;  -
;--
no_00:	cpi	XL,LOW(Bufer+8)	;  8 
	brne	c_wr_buf	; 
;\\---    ,   
	rjmp	main_cikl	;
;\----
;=====================================================
;      (0xf0)
rec1off:			;  
	cbr	STATUS,1<<f_off	;  
;   Shift
	cpi	data,0x12	; Shift ?
	brne	no_shift_off	; 
;   Shift  ,    
;    Shift      
; (Shift    )
	sbr	STATUS,1<<f_sh_off;    Shift
	rjmp	new_scan	;  
no_shift_off:
;   Scroll Lock
	cpi	data,0x5f	;  Scroll Lock ?
	breq	ignore
;   Num Lock
	cpi	data,0x76	;  Num Lock ?
	breq	ignore
;----------------------------------------------------
;--       
	ldi	XH,HIGH(Bufer)	;  
	ldi	XL,LOW(Bufer)
	sbr	STATUS,1<<f_clr	;    = 1
c_del_buf:
	ld	temp,X+		;  
	cp	temp,data	;   
	brne	no_cp		;   
;-      
	clr	t_kbd		;   . 
	st	-X,t_kbd	;  00h  
	cbr	STATUS,1<<f_clr	;    = 0
	inc	XL		;  
no_cp:	cpi	XL,LOW(Bufer+8)	;  8 
	brne	c_del_buf	; 
;--      ,   
	sbrc	STATUS,f_clr	;  f_clr = 1, 
ignore:	rjmp	clr_cikl	;   
;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
;*****      *****
new_scan:
;   
	ldi	XH,HIGH(Bufer2)
	ldi	XL,LOW(Bufer2)	; 
c_clr_buf:
	st	X+,r_00		;   0
	cpi	Xl,LOW(Bufer2+16);  16 
	brne	c_clr_buf	; 
;   
	cbr	STATUS,1<<f_scan;   = 0
	ldi	XL,LOW(Bufer)	;
;/====
c_tst_buf:
	ld	temp,X+		;   
	tst	temp		;  00h
	breq	next_b		;    
;    00h,      KBD
	lsl	temp		; *2 (    )
	ldi	ZH,high(tab_kbd*2);   
	ldi	ZL,low(tab_kbd*2) ;
	add	ZL,temp		; Z=  
;    LAT(ScrLoc=0)   RUS(ScrLoc=1)
	sbrc	STATUS2,ScrLoc	;
	inc	ZL
	lpm			;r0 =  1  
;        adrXX
	rcall	set_scan
next_b:	cpi	XL,LOW(Bufer+8)	;  8 
	brne	c_tst_buf	; 
;\\==============================
;-       (f_scan=0),
;     
	sbrc	STATUS,f_scan
	rjmp	yes_scan
;       Shift
	rcall	tst_f_sh	;
;       Shift
	sbrs	STATUS,f_shift	;  , 
	rjmp	clr_cikl	; 
	rcall	wr_shift	; Shift
yes_scan:
;------------------------------------------------------
;       
	ldi	XH,HIGH(Bufer2)	; 
	ldi	XL,LOW(Bufer2)
;   
	ldi	ZH,HIGH(Bufer_SC); 
	ldi	ZL,0xFF		;Y7..Y0=0xff
	st	Z,r_00		;  0
	ldi	ZL,0xFE		;D0=0 -> /Y0
c1mov:	ld	temp,X+		;  
	st	Z,temp		;  
	sec			;CY=1
	rol	ZL		;   
	brcs	c1mov		;    
;    -> Y10,Y9,Y8
	ldi	ZL,LOW(Bufer_SC+6);Y10=1;Y9=1;Y8=0
	ld	temp,X+		;   Y8=0
	st	Z,temp		;  
	ldi	ZL,LOW(Bufer_SC+5);Y10=1,Y9=0;Y8=1
	ld	temp,X+		;   Y9=0
	st	Z,temp		;  
	ldi	ZL,LOW(Bufer_SC+3);Y10=0,Y9=1;Y8=1
	ld	temp,X+		;   Y10=0
	st	Z,temp		;  
;    Y10=0,    
	ldi	ZL,LOW(Bufer_SC+7);Y10=1,Y9=1;Y8=1
	st	Z,temp		;  
;\----    -  
;=====
;    
	in	ZL,PIND		;   Y7..Y0
	cpi	ZL,0xFF		;
	brne	yes_7_0		;
;   Y10..Y8
	in	ZL,PINC		;   Y10..Y8
	andi	ZL,0x07		;    
	ori	ZL,LOW(Bufer_SC);   
yes_7_0:
	ld	temp,Z		; -   .
	out	DDRB,temp	;    0  
	out	PORTB,r_00	;
	rjmp	main_cikl	;   
;\===================================================
;      :
; 7		   - AltTab
;   6 5 4 3	   -         (0..10)
;           2 1 0  -     (0..7)
set_scan:
	inc	r0		;-  
	brne	yes_byte	; = 0xff,  
;     Shift,    
tst_f_sh:
	sbrs	STATUS,f_sh_off	
	ret
	cbr	STATUS,1<<f_sh_off
	cbr	STATUS,1<<f_shift
	ret
yes_byte:
	dec	r0		;
;      
; (D7 = 1)
	sbrc	r0,7
	rjmp	yes_altsh	;d7=1 -> AltTab
;      -, 
;      SHIFT
	rcall	tst_f_sh	;   
; ,    Shift
	sbrc	STATUS,f_shift	; ,
	rcall	wr_shift	; Shift
;--------
set2scan:
	sbr	STATUS,1<<f_scan; -
;     -
	mov	temp,r0		;
	andi	temp,0x07	;  (0..7)
	mov	tempA,temp      ;  0  7
	inc	tempA		; 1...8
	ldi	temp,0x01	;  PB0
c2rot:	dec	tempA		;
	breq	e2rot
	lsl	temp		;<-
	rjmp	c2rot
e2rot:
	push	XH
	push	XL
	ldi	XH,HIGH(Bufer2)
	mov	XL,r0		;-  
	lsl	XL		; <-
	swap	XL		;  -> d3..d0
	andi	XL,0x0f		; 
	subi	XL,-(LOW(Bufer2));  .
wr_scc:	ld	tempA,X		;  
	or	tempA,temp	; +  -
	st	X,tempA		;   
	pop	XL
	pop	XH
	ret
;--------------------------------------------------
;  -   
yes_altsh:
	mov	temp,r0
	andi	temp,0x7f	;  
	lsl	temp		;*2 (  )
	ldi	ZH,high(alttab*2)
	ldi	ZL,low(alttab*2)
	add	ZL,temp		; Z=  
	sbrc	STATUS,f_shift
;       Shift
	inc	ZL
	lpm			;r0 =   
	sbrc	r0,7		;  7 = 1,
	rcall	wr_shift	;  Shift
	rjmp	set2scan
;-----
;     - Shift(Y6/X0)
wr_shift:
	push	XH
	push	XL
	ldi	XH,HIGH(Bufer2)
	ldi	XL,LOW(Bufer2+6);-> Y6
	ldi	temp,0x01	;-> X0
	rjmp	wr_scc
;--------------------------------------------------
;//////////////////////////////////////////////////
;--------------------------------------------------
;	  
clr_buf:
	clr	STATUS		;
	out	PORTB,r_00	; B  0
	out	DDRB,r_00	;	  
	ldi	YH,HIGH(Bufer_SC);  
;     (8 )
	ldi	ZH,HIGH(Bufer)
	ldi	ZL,LOW(Bufer)
	ldi	count,8
c_clr:	st	Z+,r_00		;   0
	dec	count		; 8 
	brne	c_clr		; 
;   - 
	ldi	ZH,HIGH(Bufer_SC)
	ldi	ZL,low(Bufer_SC)
r_clr:	st	Z+,r_00		;  0
	tst	ZL		;  
	brne	r_clr		;
;---
	clr	t_kbd		;  =00h
	sei			; 
	ret
;***************************************************
;	   PS/2
receive:
	cbi	DDRC,CLK	; CLK   _/~
;  -  
	clr	temp
	clr	data		;Time out=256*256~65 
w_start_rd:
	dec	temp		;1
	brne	w_tout		;1/2
	dec	data		;1
	breq	clk_0		;1   time out

w_tout:	sbic	PINC,DAT	;1/2   DAT ~\_ ?
	rjmp	w_start_rd      ;2 
				;7
;
wclk50:	sbic	PINC,CLK	;CLK  ~\_
	rjmp	wclk50		;  0
	;---			;START BIT
wclk51:	sbis	PINC,CLK	;CLK  _/~
	rjmp	wclk51		;  1
;
	ldi	count,8		; 8   
;-----\   ------------
c_reciv:
wclk60:	sbic	PINC,CLK	;CLK  ~\_
	rjmp	wclk60		;  0
	clc
	sbic	PINC,DAT	; 
	sec			;CY = DAT
	ror	data
wclk61:	sbis	PINC,CLK	;CLK  _/~
	rjmp	wclk61		;  1
	dec	count
	brne	c_reciv		;  8 
;-----/   -------------
wclk70:	sbic	PINC,CLK	;CLK  ~\_
	rjmp	wclk70		;  0
	;---			;  ()
wclk71:	sbis	PINC,CLK	;CLK  _/~
	rjmp	wclk71		;  1
;
wclk80:	sbic	PINC,CLK	;CLK  ~\_
	rjmp	wclk80		;  0
	;---			; 
wclk81:	sbis	PINC,CLK	;CLK  _/~
	rjmp	wclk81		;  1
;    PS/2
clk_0:	cbi	PORTC,CLK	;CLK = 0
	sbi	DDRC,CLK	;CLK ~\_
	ret
;--------------------------------------------------
;	  
set_ind:
	ldi	data,0xed	; 
	rcall	trans_ack	;
	mov	data,STATUS2
;------------------------------------------
;	  data  
trans_ack:
	rcall	transmit	; data
	rcall	receive		;  
	cpi	data,0xfe	;  0FEh
	breq	trans_ack	;
	cpi	data,0xfa	;  ACK
	ret			; Z=1
;	   PS/2
; data -    
transmit:
	rcall	clk_0		; CLK ~\_
	rcall	del_100m	;  100 .
	cbi	PORTC,DAT	;DAT=0
	sbi	DDRC,DAT	; DAT  
	rcall	del_5m		; DAT ~\_
	cbi	DDRC,CLK	; CLK _/~
	rcall	del_5m		;  5 .
;      
;  CLK ~\_     15 
;       2 
	ldi	count,8		;8   
	clr	paritet		;  = 0
;/-----     ---
c_trans:
wclk00:	sbic	PINC,CLK	;CLK ~\_ ?
	rjmp	wclk00		;   1
;   
	ror	data		;d0->C->d7-> - - ->
;	 CY => DAT
	brcs	bit_1		; CY = 0
	cbi	PORTC,DAT	;	DAT=0
	rjmp	bit_0		; 
bit_1:	sbi	PORTC,DAT	;	DAT=1
	inc	paritet		;   + 1
bit_0:
wclk01:	sbis	PINC,CLK	;CLK = 1 ?
	rjmp	wclk01		;  1
	dec	count
	brne	c_trans		; 8 
;\-----     ----
wclk20:	sbic	PINC,CLK	;CLK  ~\_
	rjmp	wclk20		;  0
;	  = paritet.0
	sbi	PORTC,DAT       ; =1
	sbrc	paritet,0	;    d0=0
	cbi	PORTC,DAT	;	=0
wclk21:	sbis	PINC,CLK	;CLK  _/~
	rjmp	wclk21		;  1
;----
wclk30:	sbic	PINC,CLK	;CLK  ~\_
	rjmp	wclk30		;  0
	sbi	PORTC,DAT	;  = 1
wclk31:	sbis	PINC,CLK	;CLK  _/~
	rjmp	wclk31		;  1
;----
	cbi	DDRC,DAT	; DAT  
;
wclk40:	sbic	PINC,CLK	;CLK  ~\_
	rjmp	wclk40		;  0
;---				;RECEIVE ACK_B (IGNORED)
wclk41:	sbis	PINC,CLK	;CLK  _/~
	rjmp	wclk41		;  1
	ret
;-------------------------------------------
;	 0.5 
del_05:	ldi	count,50
c_d1s:	rcall	del_10        	; 10 
	dec	count
	brne	c_d1s
	ret
;  10 
del_10:	ldi	temp,100
	mov	tempA,temp
c_d10:	rcall	del_100m	; 10 
	dec	tempA
	brne	c_d10
	ret
;  100 
del_100m:
	ldi	temp,100*2      ;
	rjmp	c_del
;	 5 	( 8 )
del_5m:
	ldi	temp,5*2	;
c_del:	nop			;1
	dec	temp		;1
	brne	c_del		;1/2
				;4-> 0.5 
	ret			;
;------------------------------------------------
;	data = EEPROM(R_ind)
;rd_rom:	sbic	EECR,EEPE	; 
;	rjmp	rd_rom		;
;   
;	ldi	temp,R_ind	;
;	out	EEARL,temp	; 
;	out	EEARH,r_00
;	sbi	EECR,EERE	; 
;	in	data,EEDR	; 
;   
;	andi	data,1<<NumLoc|1<<ScrLoc ; 
;	mov	temp,STATUS2
;	andi	temp,1<<CapLoc	;Caps Lock    STATUS2
;	or	data,temp	;
;	mov	STATUS2,data	;  
;	ret
;-------------------------------------------
;	EEPROM(R_ind) = data
;wr_rom:	sbic	EECR,EEPE	; 
;	rjmp	wr_rom		;
;   
;	ldi	temp,R_ind	;
;	out	EEARL,temp	; 
;	out	EEDR,data	;  
;	sbi	EECR,EEMPE	;   EEPROM
;	sbi	EECR,EEPE	; 
;	ret
;-===========================================
;*******   *******************
